/*
 *   kwrl - a little VRML 2.0 viewer
 *   Copyright (C) 1998,99  Mark R. Stevens
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */


#ifndef NORMALINTERPOLATOR
#define NORMALINTERPOLATOR

// label
#define NormalInterpolatorLabel "NormalInterpolator"

// classes
#include <SFNode.h>
#include <MFVec3f.h>
#include <MFFloat.h>
#include <SFString.h>

// class definition
class NormalInterpolator : public SFNode {

 public:

  // constructor
  NormalInterpolator() : SFNode(NormalInterpolatorLabel) {
  }
    
  // destructor
  ~NormalInterpolator() {
  }

  // parse
  void parse   (char     *, istream &);

  // events
  void eventIn (SFString &, SFNode  *);
  void eventOut(SFString &, SFNode  *);

  // operators
  NormalInterpolator &operator = (NormalInterpolator &N2) {
    key                        = N2.key;
    keyValue                   = N2.keyValue;
    value_changed              = N2.value_changed;
    isValid()                  = N2.isValid();     
    return(*this);
  }

  // USE-DEF
  SFNode *findDEF(SFString &UnsatUSE) {
    if (UnsatUSE == DEF) return(this);
    return((SFNode *) 0);
  }
  SFString *use() {
    return(&USE);
  }

 protected:

 private:

  // data
  MFFloat key;
  MFVec3f keyValue;

  // event data
  SFVec3f value_changed;

  // USE-DEF
  SFString DEF;
  SFString USE;

};

#endif // NormalInterpolator

